	program fsfv
*	this code allows the prediction of:
* 		the shear slip factor fs
*		the velocity factor   fv
*	of the extended Holub model for pressure drop and liquid holdup in
*	trickle bed
	real wij(100,100),wjk(100,100),xmin(2,100),xmax(2,100)
	real x(100),xmod(2,100),y(100)
	data g /9.8/
*       the file fs.w and fv.w contain neural model parameters:
	open(1,file="fs.w",status="old")	 
	open(2,file="fv.w",status="old")	 

	read(1,*) ii,jj,kk
	do 10 i=1,ii
	  read(1,*) xmax(1,i),xmin(1,i),xmod(1,i)
10	continue
	do 20 i=1,kk
	  read(1,*) xmax(2,i),xmin(2,i),xmod(2,i)
20	continue
       	do 30 i=1,ii+1
	  read(1,*) (wij(i,j),j=1,jj)
30        continue
	do 40 j=1,jj+1
	  read(1,*) (wjk(j,k),k=1,kk)
40        continue
	close(1)
********************Input data**********************
*LIQUID PROPERTIES 					
*density kg/m3
	rol = 1000.
*viscosity kg/m.s
	xmul = .001
*surface tension kg/s2
	sigl = .072
*superficial velocity m/s
	ul = .0132
*GAS PROPERTIES
*density kg/m3
	rog = 3.18
*viscosity kg/m.s
	xmug = 1.7e-05   
*superficial velocity m/s
	ug =.0127

*PARTICLE AND BED PROPERTIES
*equivalent grain diameter m
	dv = .0014            
*porosity 
	eps =.35
*column diameter m
	dc =.023           
********************************************
	rel =  dv * rol * ul / xmul/(1-eps)
	reg = dv * rog * ug / xmug/(1-eps)
	frl=ul**2./g/dv
	webl=ul**2.*dv*rol/sigl
	xl=ul*rol**0.5/(ug*rog**0.5)
	stl= xmul*ul/rol/g/dv**2.
	x(1)= rel
	x(2)=reg
	x(3)=frl
	x(4)=webl
	x(5)=xl
	x(6)=stl
	
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y)	
	write(6,77)  y(1)
77      format('fs = ',f8.4)
	read(2,*) ii,jj,kk
	do 510 i=1,ii
	  read(2,*) xmax(1,i),xmin(1,i),xmod(1,i)
510	continue
	do 520 i=1,kk
	  read(2,*) xmax(2,i),xmin(2,i),xmod(2,i)
520	continue
       	do 530 i=1,ii+1
	  read(2,*) (wij(i,j),j=1,jj)
530        continue
	do 540 j=1,jj+1
	  read(2,*) (wjk(j,k),k=1,kk)
540        continue
	close(2)

	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y)	     
	write(6,78) y(1)
78      format('fv = ',f8.4)
	end
*****************************************************************	
	subroutine fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y)
	real wij(100,100),wjk(100,100),xmin(2,100),xmax(2,100)
	real x(100),u(100),h(100),s(100),xmod(2,100),y(100)
*       neural network equations:
	  do 100 i=1,ii
	  if (xmod(1,i).eq.0.) then
	    u(i)=(x(i)-xmin(1,i))/(xmax(1,i)-xmin(1,i))
	  else
	    u(i)=(log10(x(i))-xmin(1,i))/(xmax(1,i)-xmin(1,i))
	  endif
100       continue
	  u(ii+1)=1.
          do 110 j=1,jj
            h(j)=0.
            do 120 i=1,ii+1
120         h(j)=h(j)+wij(i,j)*u(i)
110       h(j)=1./(1.+exp(-h(j)))
          h(jj+1)=1.
          do 130 k=1,kk
            s(k)=0.
            do 140 j=1,jj+1
140         s(k)=s(k)+wjk(j,k)*h(j)
          s(k)=1./(1.+exp(-s(k)))
          y(k)=xmin(2,k)+s(k)*(xmax(2,k)-xmin(2,k))
          if(xmod(2,k).eq.1.) then
            y(k)=10.**(y(k))
          endif
130       continue 
	  return
          end
